<?php

namespace Bydedi\Security;

interface AuthenticateInterface
{
    /**
     * Check if user is authenticated
     *
     * @return bool
     */
    public function check();

    /**
     * Return current authenticated user
     *
     * @return UserInterface
     */
    public function getUser();

    /**
     * Logs in user
     *
     * @param UserInterface $user
     * @return mixed
     */
    public function login(UserInterface $user);

    /**
     * Authenticate user
     *
     * @param array $credentials
     * @return bool
     */
    public function auth(array $credentials);

    /**
     * Deauthenticate user
     *
     * @return void
     */
    public function logout();
}
