<?php

namespace Bydedi\Template\DependencyInjection\Compiler;

use Symfony\Component\DependencyInjection\Reference;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;

/**
 * Class RegisterTemplatePluginPass
 * @package Bydedi\Template\DependencyInjection\Compiler
 */
class RegisterTemplatePluginPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container)
    {
        if (!$container->findDefinition('template')) {
            return;
        }

        $plugins = $container->findTaggedServiceIds('app.template_plugin');
        $definition = $container->findDefinition('template');
        foreach ($plugins as $id => $args) {
            $definition->addMethodCall('registerPlugin', array(new Reference($id)));
        }

    }
}
